package com;

import org.jdom.*;
import org.jdom.input.SAXBuilder;
import java.io.*;
import java.util.*;
/**
 * Scandisce un file xml che contiene i dati dei clienti
 * e genera una teoria logica di fatti prolog
 * @author  Raffaele
 */

public class Parser {
	String nomeFile;
	public Parser(String nomeFile){this.nomeFile=nomeFile;start(nomeFile);}



	public void start(String nomeFile){
		try {
			SAXBuilder builder = new SAXBuilder();
			Document doc = builder.build(new File(nomeFile));
			List children = doc.getRootElement().getChildren();
			int NumOfClients = children.size();
			System.out.println(NumOfClients);
            Iterator iterator = children.iterator();

            for(int i=1;i<=NumOfClients;i++){
				    Element item = (Element)iterator.next();
					String path = "./simulazione/";
					String name = "cliente"+i+".pl";
					String fullpath = path.concat(name);
					System.out.println(fullpath);
					makeTheory(fullpath,item,iterator);
			    }

		}//try
		catch(JDOMException e) {
			System.err.println("Errore durante il parsing del documento " + nomeFile);
			e.printStackTrace();
	    }
     }//start
	 public static PrintWriter creaFile(String fileName){
		 String nomeFile;
	     FileWriter fw;
	     BufferedWriter bw;
	     PrintWriter outFile=null;
	     try{
			 nomeFile = new String(fileName);
	         fw = new FileWriter (nomeFile);
	         bw = new BufferedWriter (fw);
	         outFile = new PrintWriter (bw);
	         }catch(IOException e ){System.err.println("Parser : Non sono riuscito a creare il file!");}
	         return outFile;
	 }//creaFile



     public static void makeTheory(String file,Element item,Iterator iterator){
		 int count=0;//indice degli array
         String[] serv;//array
         PrintWriter outFile = creaFile(file);
	     Element reg = item.getChild("registration");
	     outFile.println("simula:-");
	     outFile.println("registration("+reg.getText()+"),");

	     Element assets = item.getChild("assets");
		 outFile.println("conto("+reg.getText()+","+assets.getChild("contocorrente").getText()+"),");
		 outFile.println("cash("+reg.getText()+","+assets.getChild("cassa").getText()+"),");
		 String casa = assets.getChild("casa").getText();
		 if(!casa.equals("no")){
		 outFile.println("home("+assets.getChild("casa").getText()+"),");}

	     List service = item.getChildren("services");
	     iterator = service.iterator();
	     while(iterator.hasNext()){
			 Element e = (Element)iterator.next();

	         if(e.getChild("bancomat")!=null){
				Element bancomat = e.getChild("bancomat");
				outFile.println("bancomat("+reg.getText()+","+bancomat.getText()+"),");
				}
	         if(e.getChild("prelievo")!=null){
			 	Element prelievo = e.getChild("prelievo");
			 	outFile.println("prelievo("+reg.getText()+","+prelievo.getText()+"),");
				}
	         if(e.getChild("versamentoConto")!=null){
			 	Element versaConto = e.getChild("versamentoConto");
			    outFile.println("versamento("+reg.getText()+"," +"conto"+ "," +versaConto.getText()+"),");
				}
	         if(e.getChild("versamentoCassa")!=null){
			 	Element versaCassa = e.getChild("versamentoCassa");
			 	outFile.println("versamento("+reg.getText()+"," +"cassa"+ "," +versaCassa.getText()+"),");
				}
	         if(e.getChild("mutuo")!=null){
			 	Element mutuo = e.getChild("mutuo");
			 	outFile.println("mutuo("+reg.getText()+","+mutuo.getText()+"),");
				}
	         }//while


	     outFile.print("true. %EndOfFile");
	     outFile.close();
	 }//makeTheory



}//Parser


