
%
% Template di un Agente Cliente:
% Ha una serie di clausole che corrispondono ai servizi che pu chiedere.
% E'un modello generale in quanto le azioni specifiche che esso far 
% sono contenute in una teoria separata, in cui sono scritti una serie di
% fatti che corrispondono alla serie di servizi che l'Agente-Cliente richieder
% questa separazione permette di mantenere un unico modello di Agente Cliente
% e di simulare tanti comportamenti diversi cambiando solo le teorie dei fatti.

% Author Raffaele Boschetti - 19/11/2004
% La banca  modellata con un centro di tuple che funge da tramite per l'interazione
% delle due societ di agenti: gli agenti-clienti quando vogliono un servizio dalla
% banca lo comunicano tramite la scrittura di una tupla che specifica di quale servizio  
% si tratti, dall'altre parte abbiamo i servitori, ovvero gli agenti-bancari che, 
% osservando continuamente il centro di tuple banca, rispondono ai servizi richiesti  




agente:-
%Carica la libreria Tucson2PLibrary.
load_library('alice.tucson.api.Tucson2PLibrary'),
enter_context([agent_id(cliente)]),
simula,
request.


% Registra se stesso al centro di tuple "banca"
% tale registrazione  necessaria in quanto i 
% servizi della banca sono disponibili ai soli affiliati 
% Quindi gli agenti bancari devono per prima cosa verificare
% se il cliente  o meno affiliato alla banca
% L'atto di registrazione simula quindi la scelta della nostra 
% banca da parte del cliente  
%
%

registration(ID) :- 
	banca ? out(cliente(ID)).

conto(ID,Import):- ID ? out(conto(Import)). 


cash(ID,Money):- ID ? out(cassa(Money)).


home(Value):- assertz(casa(Value)).
         

%Se il cliente voule il servizio di prelievo immediato 
%(il bancomat permette di prelevare una somma limitata di danaro) 
%
bancomat(ID,S) :-
	banca ? out(bancomat(ID,S)).
	        

prelievo(ID,S):-
        banca ? out(prelievo(ID,S)).

versamento(ID,Service,S):-
        banca ? out(versamento(ID,Service,S)).


%servizio lettura conto/cassa in banca



request:- leggi,
          request.


leggi:-   
   banca ? in(request(ID,Info)),
   Info==casa,!,
   immobile;
   assertz(service).


immobile:- 
casa(V),!,
(banca ? out(casa(V)));
(banca ? out(casa(no))). 

simula:-
registration(raffaele),
conto(raffaele,1000),
cash(raffaele,1000),
home(100000),
bancomat(raffaele,500),
prelievo(raffaele,500),
versamento(raffaele,conto,500),
versamento(raffaele,cassa,500),
bancomat(raffaele,1000),
prelievo(raffaele,1000),
true. %EndOfFile
